#ifndef __REALMBACKGROUNDSCROLLER_H
	#define __REALMBACKGROUNDSCROLLER_H

#include "HexSpiralCoordinate.h"

class SDL_Texture;
class SDL_Renderer;
class RealmSceneView;
class RealmMapDisplay;

class RealmBackgroundScroller {
public:
	RealmBackgroundScroller(int hex_radius, int grid_size, bool inverted, int maps_radius);
	~RealmBackgroundScroller();

	void setHexRadius(int hex_radius);

	void makeTextures(SDL_Renderer* renderer);
	void destroyTextures();
	void populateTextures(SDL_Renderer* renderer);

	void setCenter(HexSpiralCoordinate new_center, bool force_update = false);

	void setMapDisplay(RealmMapDisplay* display) { MapDisplay = display; }

	void update(RealmSceneView* scene_view);
	void updateTextures(SDL_Renderer* renderer);
	void draw(SDL_Renderer* renderer);

private:
	int OuterSpiralSize;
	int InnerSpiralSize;
	int HexRadius, MapWidth, MapHeight;
	int MapsRadius;

	SDL_Texture** Texture;
	int GridSize;
	bool Inverted;
	bool TextureSizeChanged;
	XYLocation* TextureScreenLocation;

	RealmMapDisplay* MapDisplay;

	HexSpiralCoordinate CurrentCenterCoordinate;
	bool NeedsUpdate;

	void updateDimensions();
	int getTextureIndex(int i);

};

#endif // __REALMBACKGROUNDSCROLLER_H
