#include "RealmCharacterGroup.h"
#include "RealmView.h"
#include "RealmCharacterGroupPositioner.h"
#include "RealmCharacterObjectPositioner.h"

RealmCharacterGroup::RealmCharacterGroup(RealmView* master_view) :
					Members {
								RealmCharacterObject(this),
								RealmCharacterObject(this),
								RealmCharacterObject(this),
								RealmCharacterObject(this),
								RealmCharacterObject(this),
								RealmCharacterObject(this),
								RealmCharacterObject(this)
					}
{

	MasterView = master_view;

	RealmSceneView* scene_view, *zone_view, *region_view, *realm_world_view;
	scene_view = MasterView->getSceneView();
	zone_view = MasterView->getZoneView();
	region_view = MasterView->getRegionView();
	realm_world_view = MasterView->getRealmWorldView();

	HexSpiralCoordinate start_scene_coordinate(0), start_zone_coordinate(0), start_region_coordinate(0), start_realm_coordinate(0);

	Positioner = new RealmCharacterGroupPositioner(
													scene_view, start_scene_coordinate,
													zone_view, start_zone_coordinate,
													region_view, start_region_coordinate,
													realm_world_view, start_realm_coordinate);

	std::string character_files[6] =
		{"king.svg", "queen.svg", "bishop.svg", "knight.svg", "rook.svg", "pawn.svg"};

	for (int i = 0; i < 7; i++) {
		int character_size = MasterView->getBaseRadius();

		int ct = i < 6 ? i : 5;
		CharacterTypes[ct].init(character_files[ct]);

		// initialize members
		Members[i].init(&CharacterTypes[ct], character_size, character_size);
		Members[i].setObjectPositioner(Positioner->getCharacterPositioner(i));
	}
}

void RealmCharacterGroup::update() {
	Positioner->update();
}

void RealmCharacterGroup::draw(SDL_Renderer* renderer) {
	for (int i = 0; i < 7; i++) {
		Members[i].draw(renderer);
	}
}
