
#include "RealmColorMap.h"

RealmColorMap::RealmColorMap(int radiussize) {
	RadiusSize = radiussize;

	// based on given radius, calcuate the number of hexes in the map
	NumHexes = 1;
	Updated = false;

	for (int n = 1 ; n <= radiussize; n++) {
		NumHexes += 6 * n;
	}

	ColorData = new RGBColor[NumHexes];
}

RealmColorMap::~RealmColorMap() {
	delete[] ColorData;
}

void RealmColorMap::setHex(int idx, RGBColor val) {
	if (idx < NumHexes) {
		ColorData[idx] = val;
		Updated = true;
	}
}

bool RealmColorMap::hasUpdated() {
	bool was_updated = Updated;
	Updated = false;
	return was_updated;
}
