#ifndef __REALMOBJECTTYPE_H
	#define __REALMOBJECTTYPE_H

#include <SDL2/SDL.h>
#include <string>
#include <map>
#include "SVG2SDL.h"
#include "XYLocation.h"

struct RectSize {
	int w, h;

	RectSize() { w= 0; h = 0;}
	RectSize(int wi, int he) {w = wi; h=he;}

	bool operator<(const RectSize &ob) const
	{
		return w < ob.w || (w == ob.w && h < ob.h);
	}
};

class RealmObjectType {
	public:
		void init(const std::string& filename);
		void drawAt(SDL_Renderer* renderer, XYLocation center, int w, int h);
		void cleanup();

	private:
		SVG2SDL graphic;
		std::map <RectSize, SDL_Texture*> textures;
};

#endif // __REALMOBJECTTYPE_H
