
#ifndef __REALMSCENEELEVATIONMAPREPOSITORY_H
	#define __REALMSCENEELEVATIONMAPREPOSITORY_H

#include "RealmMapKey.h"
#include <map>

class RealmSceneElevationMap;
class RealmSceneElevationMasterMap;
class RealmSceneElevationSubMap;
class RealmMapDisplay;
class RealmSceneBackgroundRepository;

// generates / retrieves RealmSceneElevationMap objects based on RealmLocation
class RealmSceneElevationMapRepository {

	public:
		RealmSceneElevationMapRepository(RealmSceneBackgroundRepository* br)
			{ BackgroundRepository = br; }

		~RealmSceneElevationMapRepository();
		void init();

		RealmSceneBackgroundRepository* getBackgroundRepository() { return BackgroundRepository; }

		RealmSceneElevationMap* findSceneElevationMap(RealmMapKey k);
		RealmSceneElevationSubMap* findSceneElevationSubMap(RealmMapKey k);

	private:
		RealmSceneBackgroundRepository* BackgroundRepository;

		std::map <RealmMapKey, RealmSceneElevationSubMap *> MapsByKey;
		std::map <RealmSceneKey, std::map<long int, RealmSceneElevationMap*>*> MapsByScene;

		void addSubMap(RealmMapKey k, RealmSceneElevationSubMap* m);

		void addMapByScene(RealmSceneKey k, long int spiral_offset, RealmSceneElevationMap* m);

		RealmSceneElevationMasterMap* MasterMap;
};


#endif // __REALMSCENEELEVATIONMAPREPOSITORY_H
