
#ifndef __SCENECAMERAPOSITIONER_H
	#define __SCENECAMERAPOSITIONER_H

#include <vector>
#include "RealmObjectPositioner.h"
#include "XYAnimator.h"
#include "HexSpiralCoordinate.h"

class SceneMoveAnimator;

class SceneCameraPositioner: public RealmObjectPositioner {

private:
	std::vector<SceneMoveAnimator*> ObjectAnimators;

	SceneMoveAnimator* LastAnimator;
	SceneMoveAnimator* TargetAnimator;
	XYAnimator CrossObjectAnimator;
	XYLocation TraversedOffset;
	bool IsBetweenAnimators;

	unsigned int CurrentObjectIndex;

public:
	SceneCameraPositioner();
	virtual ~SceneCameraPositioner() { }

	void addObjectAnimator(SceneMoveAnimator* object_animator);

	void cycleObjectAnimator();

	// for the RealmSceneView getScreenLocation implementation...
	HexSpiralCoordinate getHexPosition();
	XYLocation getCurrentOffset();
	SceneMoveAnimator* getTargetAnimator() { return TargetAnimator; }

	virtual double getScaleFactor() { return 1; } // stub mostly for now, unlikely to be used on this (unless we wanted to add lense scaling later?)
	virtual XYLocation getScreenLocation();

	void update();
};


#endif // __SCENECAMERAPOSITIONER_H
