#ifndef __XYANIMATOR_H
	#define __XYANIMATOR_H

#include "XYLocation.h"

class XYAnimator {
private:
	int MovementSpeed;
	int MaxMovementSpeed;

	XYLocation LastLocation;
	XYLocation TargetPixel; // was MoveTargetPixel

	double XMoveRatio, YMoveRatio;
	double XOffset, YOffset;

public:
	XYAnimator();

	void setPosition(XYLocation pos) { LastLocation = pos; }
	void setPosition(int x, int y) { LastLocation.setxy(x, y); }
	void stop() { MovementSpeed = 0; XMoveRatio = YMoveRatio = 0; }

	XYLocation getPosition() { return XYLocation(LastLocation.x + XOffset, LastLocation.y + YOffset); }
	void resetPosition() { LastLocation = getPosition(); XOffset = 0; YOffset = 0; }
	XYLocation getOffset() { return XYLocation(XOffset, YOffset); }

	void doMove(XYLocation target);
	bool advanceFrame();

};


#endif // __XYANIMATOR_H
