#ifndef __XYLOCATION_H
	#define __XYLOCATION_H

class XYLocation {
public:
	long int x, y;

	XYLocation() { x = 0; y = 0; }
	XYLocation(long int nx, long int ny) { x = nx; y = ny; }
	long int getx() const { return x; }
	long int gety() const { return y; }
	void setx(long int nx) { x = nx ; }
	void sety(long int ny) { y = ny; }
	void setxy(long int nx, long int ny) { x = nx; y = ny; }

	void negate() { x = -x; y = -y; }

	 XYLocation operator - (const XYLocation &ob) const { return XYLocation(x - ob.x, y - ob.y); }
	 XYLocation operator + (const XYLocation &ob) const { return XYLocation(x + ob.x, y + ob.y); }

	 // find a point on the line between a and b at progress
	 // (progress between 0 and 1, but other values could get other points on the same line outside a-b)
	 static XYLocation findPointBetween(XYLocation point_a, XYLocation point_b, double progress) {
		return XYLocation(point_a.x + (point_b.x - point_a.x) * progress, point_a.y + (point_b.y - point_a.y) * progress);
	 }
};

#endif // __XYLOCATION_H
